
class TDI
{
	char add; // indirizzo
	int p;    // porta
	int h;	  //hop
	int c;	  //costo
	/**
	 * @param add
	 * @param p
	 * @param h
	 * @param c
	 */
	public TDI(char add, int p, int h, int c) {
		this.add = add;
		this.p = p;
		this.h = h;
		this.c = c;
	}
}

class LINK
{
	String ra; //il router ra  connesso...
	String rb; //...al router rb	
	int p;	   //... sulla porta p (di ra)	
	/**
	 * @param ra
	 * @param rb
	 * @param p
	 */
	public LINK(String ra, String rb, int p) {
		this.ra = ra;
		this.rb = rb;
		this.p = p;
	}
}


public class jNextHop {
	private TDI[] tdiR1;
	private TDI[] tdiR2;
	private TDI[] tdiR3;
	private LINK [] linkrouter;

	public jNextHop()
	{
		//inizializzo le strutture.
		tdiR1 = new TDI[3];		
		tdiR1[0] = new TDI('a',1,0,0); tdiR1[1] = new TDI('b',2,1,5); tdiR1[2] = new TDI('c',2,2,2); 
		
		tdiR2 = new TDI[3];
		tdiR2[0] = new TDI('a',3,1,0); tdiR2[1] = new TDI('b',7,0,5); tdiR2[2] = new TDI('c',2,1,2); 
		
		tdiR3 = new TDI[3];
		tdiR3[0] = new TDI('a',9,2,0); tdiR3[0] = new TDI('b',8,1,5); tdiR3[0] = new TDI('c',9,0,0); 
		
		linkrouter = new LINK[4];		
		linkrouter[0] = new LINK("R1","R2",2); 
		linkrouter[1] = new LINK("R2","R1",4); 
		linkrouter[2] = new LINK("R2","R3",2); 
		linkrouter[3] = new LINK("R3","R2",5); 
		
	}
	
	public void Calcola(char chS,char chD)
	{
		int h,r,p = 0;
		h = -1;  r = 1;
		String szHops = "\0";
		TDI[] tdi = null;
		
	    szHops = szHops.concat(String.format("%c ",chS));
		while(h != 0)
		{
			p = -1; h = -1;
			szHops = szHops.concat(String.format("R%c ",r + '0'));
			switch(r)
			{
				case 1: tdi = tdiR1; break;
				case 2: tdi = tdiR2; break;
				case 3: tdi = tdiR3; break;	
				default: return; 
			}
			for(int i = 0;i < tdi.length;i++)
			{
				if(chD==tdi[i].add)
				{
					h = tdi[i].h; p = tdi[i].p;
					break;
				}
			}
			if(h>0)
			{
				for(int j = 0; j < linkrouter.length ; j++)
				{
					if((linkrouter[j].ra.equalsIgnoreCase(String.format("R%d", r))) && (linkrouter[j].p == p))
					{
						r = Integer.parseInt(linkrouter[j].rb.substring(1));
						break;
					}					
				}
			}
			else
			{
				if(h == 0) 
					szHops = szHops.concat(String.format("%c", chD));
				else
				{
					System.out.printf("\nImpossibile instradare");
					return;
				}
			}
		}		
		System.out.printf("\nPercorso: %s",szHops);			
	}
}


